/**
 * OW2 Util
 * Copyright (C) 2008 Bull S.A.S.
 * Contact: easybeans@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 *
 * --------------------------------------------------------------------------
 * $Id: IJCommonBean.java 2950 2008-04-25 09:14:23Z gaellalire $
 * --------------------------------------------------------------------------
 */

package org.ow2.util.ee.metadata.ejbjar.api.struct;

import java.util.List;

/**
 * IJCommonBean.
 * @author Gael Lalire
 */
public interface IJCommonBean {

    /**
     * @return the description.
     */
    String getDescription();

    /**
     * Sets the description.
     * @param description value of description
     */
    void setDescription(final String description);

    /**
     * @return the mapped name (JNDI ?)
     */
    String getMappedName();

    /**
     * Sets the mapped name.
     * @param mappedName the value to set
     */
    void setMappedName(final String mappedName);

    /**
     * @return name of the bean.
     */
    String getName();

    /**
     * Sets the bean name.
     * @param name the bean's name
     */
    void setName(final String name);

    /**
     * @return true if the bean is the default name (set with annotation)
     */
    boolean isDefaultName();

    /**
     * Is that this name is a default name ?
     * @param defaultName boolean true/false
     */
    void setDefaultName(final boolean defaultName);

    /**
     * @return a list of aliases (ejb-names)
     */
    List<String> getAliases();

    /**
     * Adds an alias to the list of the names.
     * @param ejbName the name of the ejb
     */
    void addAlias(final String ejbName);

}
